package dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus;

import java.util.function.BiFunction;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import com.google.common.base.Preconditions;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.ChatFormatting;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.ItemStack;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import dev.shadowsoffire.placebo.util.StepFunction;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.Map;
import com.mojang.serialization.Codec;

public class DurabilityBonus extends GemBonus
{
    public static Codec<DurabilityBonus> CODEC;
    protected final Map<LootRarity, StepFunction> values;
    
    public DurabilityBonus(final GemClass gemClass, final Map<LootRarity, StepFunction> values) {
        super(Apotheosis.loc("durability"), gemClass);
        this.values = values;
    }
    
    @Override
    public Component getSocketBonusTooltip(final ItemStack gem, final LootRarity rarity) {
        final float level = this.values.get(rarity).get(0.0f);
        return (Component)Component.m_237110_("bonus." + this.getId() + ".desc", new Object[] { Affix.fmt(100.0f * level) }).m_130940_(ChatFormatting.YELLOW);
    }
    
    @Override
    public float getDurabilityBonusPercentage(final ItemStack gem, final LootRarity rarity, final ServerPlayer user) {
        return this.values.get(rarity).min();
    }
    
    @Override
    public GemBonus validate() {
        Preconditions.checkNotNull((Object)this.values, (Object)"Invalid AttributeBonus with null values");
        return this;
    }
    
    @Override
    public boolean supports(final LootRarity rarity) {
        return this.values.containsKey(rarity);
    }
    
    @Override
    public int getNumberOfUUIDs() {
        return 0;
    }
    
    public Codec<? extends GemBonus> getCodec() {
        return DurabilityBonus.CODEC;
    }
    
    static {
        DurabilityBonus.CODEC = (Codec<DurabilityBonus>)RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.gemClass(), (App)DurabilityBonus.VALUES_CODEC.fieldOf("values").forGetter(a -> a.values)).apply((Applicative)inst, (BiFunction)DurabilityBonus::new));
    }
}
